/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rational.report.web.core.app.internal.LoginDialog");

dojo.require("dijit.Dialog");
dojo.require("com.ibm.rational.report.web.core.app.internal.MessageFormatter");

var MessageFormatter		= com.ibm.rational.report.web.core.app.internal.MessageFormatter;

dojo.declare(
	"com.ibm.rational.report.web.core.app.internal.LoginDialog",
	dijit.Dialog, {
	
	postCreate: function() {
		this.inherited("postCreate",arguments);
		this.messageArea = document.createElement("div");
		this.titleBar.appendChild(this.messageArea);
		this._msgFormatter = new MessageFormatter(this.messageArea);
	},
	
	setErrorMessage: function(message) {
		if(typeof message != "undefined" && message != null){
			this._msgFormatter.displayErrorMessage(message);
		}
	},
		
	_onKey: function(/*Event*/ evt){
		if (evt.keyCode) {
			var node = evt.target;
			// see if we are shift-tabbing from titleBar
			if (node == this.titleBar && evt.shiftKey && evt.keyCode == dojo.keys.TAB) {
				if (this._lastFocusItem) {
					this._lastFocusItem.focus(); // send focus to last item in dialog if known
				}
				dojo.stopEvent(evt);
			} else {
				// see if the key is for the dialog
				while(node) {
					if (node == this.domNode) {
						if (evt.keyCode == dojo.keys.ESCAPE) {
							this.hide(); 
						} else {
							return; // just let it go
						}
					}
					node = node.parentNode;
				}
				// this key is for the disabled document window
				if (evt.keyCode != dojo.keys.TAB) { // allow tabbing into the dialog for a11y
					//dojo.stopEvent(evt);
					// opera won't tab to a div
				} else if (!dojo.isOpera) {
					try {
						this.titleBar.focus();
					} catch (e) {
						/*squelch*/
					}
				}
			}
		}
	}
	
});

})();